package net.t2code.opsecurity.config.language;

import net.t2code.opsecurity.Util;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriterLanguage;
import net.t2code.t2codelib.T2CLanguageEnum;
import net.t2code.t2codelib.T2CconfigItemLanguages;

import java.util.HashMap;
import java.util.List;

public class Languages {

    public enum VALUES implements T2CconfigItemLanguages {
        otherLang("plugin", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, null);
                    put(T2CLanguageEnum.english, null);
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Wenn du eine Eigene Sprache hinzufügen magst, dann kopiere einfach eine Sprachdatei und benenne sie in deine Sprache, dies kannst du dann in der config.yml einstellen.",""));
                    put(T2CLanguageEnum.english, List.of("If you want to add your own language, simply copy a language file and rename it to your language, you can then set this in config.yml.",""));
                }}),

        soundNotFound("plugin.soundNotFound", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Der Sound <gold>[sound]</gold> wurde nicht gefunden! Bitte überprüfe die Einstellungen.</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>The sound <gold>[sound]</gold> could not be found! Please check your settings.</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        noPermission("plugin.NoPermission", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "<dark_red>Keine Berechtigung!</dark_red>");
                    put(T2CLanguageEnum.english, "<dark_red>No Permission!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        noPermissionForOpSec("plugin.NoPermission", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <red>Du hast keine Berechtigung für OPSecurity!</red>");
                    put(T2CLanguageEnum.english, "[prefix] <red>You do not have permission for OPSecurity!</red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        playerMustBeOnlineToOp("plugin.PlayerMustBeOnlineToOp", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Der Spieler muss online sein, um OP zu erhalten!</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>Player must be online to get op!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        reloadStart("plugin.reload.start", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <gold>Plugin wird neu geladen...</gold>");
                    put(T2CLanguageEnum.english, "[prefix] <gold>Plugin is reloaded...</gold>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        reloadEnd("plugin.reload.end", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <green>Plugin wurde erfolgreich neu geladen.</green>");
                    put(T2CLanguageEnum.english, "[prefix] <green>Plugin was successfully reloaded.</green>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        opWhitelistOpCommand("opWhitelist.opCommand", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Der angegebene Spieler befindet sich nicht auf der OP_Whitelist!</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>The specified player is not on the OP_Whitelist!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        opWhitelistNotifyOnJoin("opWhitelist.notify.onJoin", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Spieler <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> ist dem Server beigetreten, befindet sich aber nicht auf der OP_Whitelist!</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>Player <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> is joined to the server but is not on the OP_Whitelist!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        opWhitelistNotifyDeop("opWhitelist.notify.deop", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Spieler <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> wurde OP entfernt da er nicht auf der Spielerliste steht!</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>Player <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> was removed OP because he is not on the playerlist!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        opWhitelistNotifyKick("opWhitelist.notify.kick", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Spieler <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> wurde gekickt, da er nicht auf der OP_Whitelist steht!</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>Player <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> was kicked because he is not on the OP_Whitelist!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        opWhitelistDeop("opWhitelist.deop", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "&4Dir wurde OP entfernt da du dazu keine Permission besitzt.");
                    put(T2CLanguageEnum.english, "&4You have been removed from OP because you do not have permission.");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        opWhitelistKick("opWhitelist.kick", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "&4Du hast OP, bist dazu aber nicht berechtigt. Deswegen wurdest du gekickt!");
                    put(T2CLanguageEnum.english, "&4You have op but are not authorized to do so, that's why you were kicked!");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        permissionWhitelistNotifyOnJoin("permissionWhitelist.notify.onJoin", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Player <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> hat die Permission <gold>[perm]</gold> und ist dazu nicht berechtigt! <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> ist nicht in der Spielerliste!</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>Player <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> has permission <gold>[perm]</gold> and is not authorized to do so! <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> is not on the Player list!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        permissionWhitelistNotifyKick("permissionWhitelist.notify.kick", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Spieler <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> hat die Permission <gold>[perm]</gold> und ist dazu nicht berechtigt! Daher wurde er gekickt! <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> ist nicht in der Spielerliste!</dark_red>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>Player <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> has permission <gold>[perm]</gold> and is not authorized to do so! Therefore he was kicked! <gold><hover:show_text:'<gold>Name:</gold> <yellow>[player]</yellow><br><gold>UUID:</gold> <yellow>[uuid]</yellow>'>[player]</hover></gold> is not on the Player list!</dark_red>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        permissionWhitelistKick("permissionWhitelist.kick", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "&4Du wurdest gekickt, da du Permissions besitzt, für die du keine Berechtigung besitzt!");
                    put(T2CLanguageEnum.english, "&4You were kicked because you have permissions to which you do not have permission!");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        exactKickReason("console.exactKickReason", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] <dark_red>Genauer Grund:</dark_red> <gold>[reason]</gold>");
                    put(T2CLanguageEnum.english, "[prefix] <dark_red>Exact reason:</dark_red> <gold>[reason]</gold>");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }});
        private final String path;
        private Object value;
        private final HashMap<T2CLanguageEnum, String> lang;
        private final HashMap<T2CLanguageEnum, List<String>> comments;

        VALUES(String path, Object value, HashMap<T2CLanguageEnum, String> lang, HashMap<T2CLanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2CLanguageEnum.english);
            }
            return value;
        }

        @Override
        public HashMap<T2CLanguageEnum, String> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2CLanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean pluginStart) {
        T2CconfigWriterLanguage.createConfig(Util.getPrefix(),Main.getPath(), VALUES.values(), Config.VALUES.language.getValue().toString(),pluginStart, Util.getConfigLogo());
    }

}
