// This class was created by JaTiTV.

package net.t2code.opsecurity.config.permissionWhitelist;

import net.t2code.opsecurity.Util;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriter;
import net.t2code.t2codelib.T2CLanguageEnum;
import net.t2code.t2codelib.T2CconfigItem;
import org.bukkit.configuration.ConfigurationSection;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class PermissionWhitelist {

    public enum VALUES implements T2CconfigItem {

        enable("permissionWhitelist.enable", false, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),
        playerWithPermissionKick("permissionWhitelist.playerWithPermissionKick", true, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),
        permissions("permissionWhitelist.permissions", Arrays.asList("*", "t2c.opsecurity.admin"), true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),
        customCommandsEnable("permissionWhitelist.customCommands.enable", false, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),
        customCommandsCommands("permissionWhitelist.customCommands.commands", Arrays.asList("lp user [player] permission unset *", "lp user [player] permission unset t2c.opsecurity.admin"), true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),

        playerSection("permissionWhitelist.whitelist", null, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),
        player1name("permissionWhitelist.whitelist.player1.name", "player1", false,
                new HashMap<>()),
        player1uuid("permissionWhitelist.whitelist.player1.uuid", "00000000000000000000000000000000", false,
                new HashMap<>()),
        player2name("permissionWhitelist.whitelist.player2.name", "player2", false,
                new HashMap<>()),
        player2uuid("permissionWhitelist.whitelist.player2.uuid", "00000000000000000000000000000000", false,
                new HashMap<>()),

        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2CLanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2CLanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2CLanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return null;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean pluginStart) {
        long long_ = System.currentTimeMillis();
        T2CconfigWriter.createConfig(new File(Main.getPath(), "permissionWhitelist.yml"), VALUES.values(), Util.getConfigLogo());
        player();

        T2Ctemplate.setCenterAligned(Util.getPrefix(), "§2permissionWhitelist.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms", pluginStart);
    }


    private static void player() {
        ConfigurationSection section = (ConfigurationSection) VALUES.playerSection.getValue();
        for (String key : section.getConfigurationSection("").getKeys(false)) {
            String name = section.getString(key + ".name");
            PlayerObject playerObject = new PlayerObject(
                    name,
                    section.getString(key + ".uuid").replace("-", ""));
            PlayerCache.getOpHashMap().put(name, playerObject);
        }
    }
}
